//------------------------------
// Title: AutoRespawn
// Author: Swollow
// Version 2
// Respawn Automatically!
//------------------------------
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
	if(!$RTB::Hooks::ServerControl)
	exec("Add-Ons/System_ReturnToBlockland/Hooks/serverControl.cs");

	RTB_registerPref("Enabled", "Auto Respawn", "$Swol::AutoRespawn_Enabled", "bool", "Server_AutoRespawn", 1, 0, 0, "rtb_autoRespawn");
}
else
{
	$Swol::AutoRespawn_Enabled = 1;
}
function rtb_autoRespawn(%oldVal, %newVal)
{
	schedule(0, 0, "messageAll", '', "\c3+ Auto Respawn\c0 - Auto Respawn is now " @ (%newVal ? "\c2enabled" : "\c0disabled") @ "\c0.");
}
package swol_AutoRespawn
{
	function serverCmdToggleAR(%client)
	{
		if(%client.isSuperAdmin)
		{
			if($Swol::AutoRespawn_Enabled)
			{
				messageAll('',"\c3" @ %client.name SPC "\c0disabled\c6 Auto Respawn");
				$Swol::AutoRespawn_Enabled = 0;
			}
			else
			{
				MessageAll('',"\c3" @ %client.name SPC "\c2enabled\c6 Auto Respawn");
				$Swol::AutoRespawn_Enabled = 1;
			}
		}
		else
		{
			messageClient(%client,'',"\c6This command is \c3Super Admin\c6 only");
		}
	}

	function gameConnection::onDeath(%client, %killerPlayer, %killer, %damageType, %a)
	{
		if(!isObject(%client.minigame))
		return parent::onDeath(%client, %killerPlayer, %killer, %damageType, %a);
		
		%mini = %client.minigame;
		

		if(%Mini.tdmLivesLimit && %client.tdmLives > 0)
		return parent::onDeath(%client, %killerPlayer, %killer, %damageType, %a);

		if(%client.lives < 2 && %Mini.lives > 0 && %Mini.isSlayerMinigame)
		return parent::onDeath(%client, %killerPlayer, %killer, %damageType, %a);
	
		if(%mini.isSlayerMinigame)
		{
			%slayerTime = %client.dynamicRespawnTime;
			schedule(%slayerTime,0,autoRespawn,%client);
			schedule(%slayerTime-500,0,autoRespawnMsg,%client);
			return parent::onDeath(%client, %killerPlayer, %killer, %damageType, %a);
		}
		
		schedule(%mini.respawnTime+%addTime,0,autoRespawn,%client);
		schedule((%mini.respawnTime+%addTime)-500,0,autoRespawnMsg,%client);

		return parent::onDeath(%client, %killerPlayer, %killer, %damageType, %a);
	}
};
ActivatePackage(swol_AutoRespawn);

function autoRespawnMsg(%client)
{
	messageClient(%client,'MsgYourSpawn');
	centerPrint(%client,"\c5Prepare to respawn",3);
}

function autoRespawn(%client)
{
	if(isObject(%client.player))
	return;

	%client.instantRespawn();
}